#ifndef _GSM_0705_H
#define _GSM_0705_H

/* Section 3.2.5 */
enum gsm0705_cms_error {
	/* 000..127 GSM 04.11 Annex E-2 values */
	/* 128..255 GSM 03.40 subclause 9.2.3.22 values */
	GSM0705_CMS_ME_FAILURE			= 300,
	GSM0705_CMS_SMS_SERVICE_OF_ME_RESERVED	= 301,
	GSM0705_CMS_OPERATION_NOT_ALLOWED	= 302,
	GSM0705_CMS_OPERATION_NOT_SUPPORTED	= 303,
	GSM0705_CMS_INVALID_PDU_PARAMETER	= 304,
	GSM0705_CMS_INVALID_TEXT_PARAMETER	= 305,
	GSM0705_CMS_SIM_NOT_INSERTED		= 310,
	GSM0705_CMS_SIM_PIN_REQUIRED		= 311,
	GSM0705_CMS_PH_SIM_PIN_REQUIRED		= 312,
	GSM0705_CMS_SIM_FAILURE			= 313,
	GSM0705_CMS_SIM_BUSY			= 314,
	GSM0705_CMS_SIM_WRONG			= 315,
	GSM0705_CMS_SIM_PUK_REQUIRED		= 316,
	GSM0705_CMS_SIM_PIN2_REQUIRED		= 317,
	GSM0705_CMS_SIM_PUK2_REQUIRED		= 318,
	GSM0705_CMS_MEMORY_FAILURE		= 320,
	GSM0705_CMS_INVALID_MEMORY_INDEX	= 321,
	GSM0705_CMS_MEMORY_FULL			= 322,
	GSM0705_CMS_SMSC_ADDRESS_UNKNOWN	= 330,
	GSM0705_CMS_NO_NETWORK_SERVICE		= 331,
	GSM0705_CMS_NETWORK_TIMEOUT		= 332,
	GSM0705_CMS_NO_CNMA_ACK_EXPECTED	= 340,
	GSM0705_CMS_UNKNOWN_ERROR		= 500,
	/* 501..511 reserved */
	/* 512..xxx manufacturer specific */
};

#endif /* _GSM_0705_H */
